select
  an.numero
  , an.dtnascimento
  , prog.nome as nome_programacao_associada
  , protprog.descricao as protocolo_programacao
  , (case when (progass.implante = 1) then 'Sim' when (progass.implante = 0) then 'No' else null end) as Implante
  , (case when (progass.perda = 1) then 'Sim' when (progass.perda = 0) then 'No' else null end) as Perda
  , ultpar.data as ultimo_parto
  , prog.dtimplante as data_implante
  , prog.dtretirada as data_retirada
  , cobpro.data as inseminacao_valida_prog
  , ultcob.data as ultima_tentativa_ciclo_atual
from
  animal an
  left join reproducao ultpar on ultpar.cdreproducao =
    (select first 1 re.cdreproducao from reproducao re where re.cdanimal = an.cdanimal and re.cdtiporeproducao = 7
        order by re.data desc)
  join programacaoiatfassociacao progass on progass.cdanimal =  an.cdanimal
  left join programacaoiatf prog on prog.cdprogramacaoiatf = progass.cdprogramacaoiatf
  left join protocoloiatf protprog on protprog.cdprotocoloiatf = progass.cdprotocoloiatf
  left join reproducao cobpro on cobpro.cdreproducao =
    (select first 1 re.cdreproducao from reproducao re where re.cdanimal = an.cdanimal and re.cdtiporeproducao in (1,2,3) and
        re.data >= (prog.dtretirada + prog.diasinseminacaoinicio) and re.data <= (prog.dtretirada + prog.diasinseminacaofim) order by re.data desc)
  left join reproducao ultcob on ultcob.cdreproducao =
    (select first 1 re.cdreproducao from reproducao re where re.cdanimal = an.cdanimal and re.cdtiporeproducao in (1,2,3) and
        re.data > coalesce(ultpar.data, '1900-01-01') order by re.data desc)
where
  an.dtbaixa is null

